{-# OPTIONS_GHC -fglasgow-exts #-}

module RedPairImpl where {

import RedPair;
import UsableRules;
import Polynomial;
import Show;
import Term;
import Util;
import Nat;
import HOL;
import List;
import Product_Type;

newtype RedPair a = NegPolo [(a, (Cint, [Nat]))];

createRuleRemovalProc ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => RedPair a ->
                    [(Term a b, Term a b)] ->
                      [(Term a b, Term a b)] -> Eithera [[Char]] ();
createRuleRemovalProc (NegPolo beta) r rR =
  let {
    alpha = createPolyInter beta;
  } in checkRuleRemovalProc (checkInterMono beta) (checkSPolo alpha)
         (checkNSPolo alpha)
         ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'o', 'r', 'd',
           'e', 'r']
         (createRepresentation alpha
           (remdups (mapa (\ (a @ (g, il)) -> (g, size_list (snd il))) beta)))
         r rR;

createMonoRedPairUrProc ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => RedPair a ->
                    [(Term a b, Term a b)] ->
                      [(Term a b, Term a b)] ->
                        [(Term a b, Term a b)] ->
                          Maybe (a -> [(Term a b, Term a b)]) ->
                            [(Term a b, Term a b)] ->
                              [(Term a b, Term a b)] -> Eithera [[Char]] ();
createMonoRedPairUrProc (NegPolo beta) p rP r rm rR ur =
  let {
    alpha = createPolyInter beta;
  } in checkMonoRedPairUrProc (checkInterMono beta) (checkSPolo alpha)
         (checkNSPolo alpha)
         ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'o', 'r', 'd',
           'e', 'r']
         (createRepresentation alpha
           (remdups (mapa (\ (a @ (g, il)) -> (g, size_list (snd il))) beta)))
         p rP r rm rR ur;

createMonoRedPairProc ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => RedPair a ->
                    [(Term a b, Term a b)] ->
                      [(Term a b, Term a b)] ->
                        [(Term a b, Term a b)] ->
                          [(Term a b, Term a b)] -> Eithera [[Char]] ();
createMonoRedPairProc (NegPolo beta) p rP r rR =
  let {
    alpha = createPolyInter beta;
  } in checkMonoRedPairProc (checkInterMono beta) (checkSPolo alpha)
         (checkNSPolo alpha)
         ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'o', 'r', 'd',
           'e', 'r']
         (createRepresentation alpha
           (remdups (mapa (\ (a @ (g, il)) -> (g, size_list (snd il))) beta)))
         p rP r rR;

createRedPairUrAfProc ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => RedPair a ->
                    [(Term a b, Term a b)] ->
                      [(Term a b, Term a b)] ->
                        [(Term a b, Term a b)] ->
                          Maybe (a -> [(Term a b, Term a b)]) ->
                            [(Term a b, Term a b)] -> Eithera [[Char]] ();
createRedPairUrAfProc (NegPolo l) p rP r rm ur =
  let {
    alpha = createPolyInter l;
  } in checkRedPairUrAfProc (checkSPolo alpha) (checkNSPolo alpha)
         ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'o', 'r', 'd',
           'e', 'r']
         (createRepresentation alpha
           (remdups (mapa (\ (a @ (g, il)) -> (g, size_list (snd il))) l)))
         p rP r rm ur (create_af l);

createRedPairProc ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => RedPair a ->
                    [(Term a b, Term a b)] ->
                      [(Term a b, Term a b)] ->
                        [(Term a b, Term a b)] -> Eithera [[Char]] ();
createRedPairProc (NegPolo interpr) p rP r =
  let {
    alpha = createPolyInter interpr;
  } in checkRedPairProc (checkSPolo alpha) (checkNSPolo alpha)
         ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'o', 'r', 'd',
           'e', 'r']
         (createRepresentation alpha
           (remdups
             (mapa (\ (a @ (g, il)) -> (g, size_list (snd il))) interpr)))
         p rP r;

}
